#!/usr/bin/env python3

import connexion
from .encoder import JSONEncoder

from .blueprint import Blueprint

if __name__ == '__main__':
    app = connexion.App(__name__, specification_dir='./swagger/')
    app.app.json_encoder = JSONEncoder
    # add by FAO
    #app.add_api('swagger.yaml', arguments={'title': 'This is a sample server for manage people. It is a sample for create angular ihm '})
    app.add_api('swagger.yaml', swagger_ui=True, arguments={'title': 'This is a sample server for manage people. It is a sample for create angular ihm '})
    app.app.register_blueprint(Blueprint('doc', __name__, static_folder='../doc', static_url_path='/doc'))
    app.app.register_blueprint(Blueprint('app', __name__, static_folder='../app', static_url_path='/'))
    # end ad by FAO
    app.run(port=8080)
