import flask 

class Blueprint(flask.Blueprint):

    def __init__(self, *args, **kwargs):
        flask.Blueprint.__init__(self, *args, **kwargs)

    def register(self, app, options, first_registration=False):
        flask.Blueprint.register(self, app, options, first_registration)
        state = self.make_setup_state(app, options, first_registration)
        if self.has_static_folder:
            state.add_url_rule(self.static_url_path,
                view_func=self.send_static_file,
                endpoint='static')
            state.add_url_rule(self.static_url_path+'/',
                view_func=self.send_static_file,
                endpoint='static')
    
    def send_static_file(self, filename="index.html"):
        return flask.Blueprint.send_static_file(self, filename)
