# coding: utf-8

from __future__ import absolute_import
from .base_model_ import Model
from datetime import date, datetime
from typing import List, Dict
from ..util import deserialize_model

from .people import InvalidGenderError

class NewPeople(Model):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, first_name: str=None, last_name: str=None, email: str=None, gender: str=None, age: int=None):
        """
        NewPeople - a model defined in Swagger

        :param first_name: The first_name of this NewPeople.
        :type first_name: str
        :param last_name: The last_name of this NewPeople.
        :type last_name: str
        :param email: The email of this NewPeople.
        :type email: str
        :param gender: The gender of this NewPeople.
        :type gender: str
        :param age: The age of this NewPeople.
        :type age: int
        """
        self.swagger_types = {
            'first_name': str,
            'last_name': str,
            'email': str,
            'gender': str,
            'age': int
        }

        self.attribute_map = {
            'first_name': 'firstName',
            'last_name': 'lastName',
            'email': 'email',
            'gender': 'gender',
            'age': 'age'
        }

        self._first_name = first_name
        self._last_name = last_name
        self._email = email
        self._gender = gender
        self._age = age

    @classmethod
    def from_dict(cls, dikt) -> 'NewPeople':
        """
        Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The newPeople of this NewPeople.
        :rtype: NewPeople
        """
        return deserialize_model(dikt, cls)

    @property
    def first_name(self) -> str:
        """
        Gets the first_name of this NewPeople.
        firstName of people

        :return: The first_name of this NewPeople.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name: str):
        """
        Sets the first_name of this NewPeople.
        firstName of people

        :param first_name: The first_name of this NewPeople.
        :type first_name: str
        """
        if first_name is None:
            raise ValueError("Invalid value for `first_name`, must not be `None`")

        self._first_name = first_name

    @property
    def last_name(self) -> str:
        """
        Gets the last_name of this NewPeople.
        lastName of people

        :return: The last_name of this NewPeople.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name: str):
        """
        Sets the last_name of this NewPeople.
        lastName of people

        :param last_name: The last_name of this NewPeople.
        :type last_name: str
        """
        if last_name is None:
            raise ValueError("Invalid value for `last_name`, must not be `None`")

        self._last_name = last_name

    @property
    def email(self) -> str:
        """
        Gets the email of this NewPeople.
        email of people

        :return: The email of this NewPeople.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email: str):
        """
        Sets the email of this NewPeople.
        email of people

        :param email: The email of this NewPeople.
        :type email: str
        """

        self._email = email

    @property
    def gender(self) -> str:
        """
        Gets the gender of this NewPeople.
        sex of people (M or F)

        :return: The gender of this NewPeople.
        :rtype: str
        """
        return self._gender

    @gender.setter
    def gender(self, gender: str):
        """
        Sets the gender of this NewPeople.
        sex of people (M or F)

        :param gender: The gender of this NewPeople.
        :type gender: str
        """
        if gender not in ('M','F'):
            raise InvalidGenderError()
        self._gender = gender

    @property
    def age(self) -> int:
        """
        Gets the age of this NewPeople.
        Age of people

        :return: The age of this NewPeople.
        :rtype: int
        """
        return self._age

    @age.setter
    def age(self, age: int):
        """
        Sets the age of this NewPeople.
        Age of people

        :param age: The age of this NewPeople.
        :type age: int
        """

        self._age = age

