# coding: utf-8

from __future__ import absolute_import
from .base_model_ import Model
from datetime import date, datetime
from typing import List, Dict
from ..util import deserialize_model

from ..error import Error

class PeopleError(Error):
    pass

class InvalidGenderError(PeopleError):
 
    def __init__(self):
        PeopleError.__init__(self,
            status=405,
            title="People error",
            type="INPUT-004")
   
    def __str__(self):
        return "invalid Gender ... M or F"



class People(Model):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """
    def __init__(self, id: int=None, first_name: str=None, last_name: str=None, email: str=None, gender: str=None, age: int=None):
        """
        People - a model defined in Swagger

        :param id: The id of this People.
        :type id: int
        :param first_name: The first_name of this People.
        :type first_name: str
        :param last_name: The last_name of this People.
        :type last_name: str
        :param email: The email of this People.
        :type email: str
        :param gender: The gender of this People.
        :type gender: str
        :param age: The age of this People.
        :type age: int
        """
        self.swagger_types = {
            'id': int,
            'first_name': str,
            'last_name': str,
            'email': str,
            'gender': str,
            'age': int
        }

        self.attribute_map = {
            'id': 'id',
            'first_name': 'firstName',
            'last_name': 'lastName',
            'email': 'email',
            'gender': 'gender',
            'age': 'age'
        }

        self._id = id
        self._first_name = first_name
        self._last_name = last_name
        self._email = email
        self._gender = gender
        self._age = age

    @classmethod
    def from_dict(cls, dikt) -> 'People':
        """
        Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The people of this People.
        :rtype: People
        """
        return deserialize_model(dikt, cls)

    @property
    def id(self) -> int:
        """
        Gets the id of this People.
        id of people

        :return: The id of this People.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id: int):
        """
        Sets the id of this People.
        id of people

        :param id: The id of this People.
        :type id: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def first_name(self) -> str:
        """
        Gets the first_name of this People.
        firstName of people

        :return: The first_name of this People.
        :rtype: str
        """
        return self._first_name

    @first_name.setter
    def first_name(self, first_name: str):
        """
        Sets the first_name of this People.
        firstName of people

        :param first_name: The first_name of this People.
        :type first_name: str
        """
        if first_name is None:
            raise ValueError("Invalid value for `first_name`, must not be `None`")

        self._first_name = first_name

    @property
    def last_name(self) -> str:
        """
        Gets the last_name of this People.
        lastName of people

        :return: The last_name of this People.
        :rtype: str
        """
        return self._last_name

    @last_name.setter
    def last_name(self, last_name: str):
        """
        Sets the last_name of this People.
        lastName of people

        :param last_name: The last_name of this People.
        :type last_name: str
        """
        if last_name is None:
            raise ValueError("Invalid value for `last_name`, must not be `None`")

        self._last_name = last_name

    @property
    def email(self) -> str:
        """
        Gets the email of this People.
        email of people

        :return: The email of this People.
        :rtype: str
        """
        return self._email

    @email.setter
    def email(self, email: str):
        """
        Sets the email of this People.
        email of people

        :param email: The email of this People.
        :type email: str
        """

        self._email = email

    @property
    def gender(self) -> str:
        """
        Gets the gender of this People.
        sex of people (M or F)

        :return: The gender of this People.
        :rtype: str
        """
        return self._gender

    @gender.setter
    def gender(self, gender: str):
        """
        Sets the gender of this People.
        sex of people (M or F)

        :param gender: The gender of this People.
        :type gender: str
        """
        if gender not in ('M','F'):
            raise InvalidGenderError()
        self._gender = gender

    @property
    def age(self) -> int:
        """
        Gets the age of this People.
        Age of people

        :return: The age of this People.
        :rtype: int
        """
        return self._age

    @age.setter
    def age(self, age: int):
        """
        Sets the age of this People.
        Age of people

        :param age: The age of this People.
        :type age: int
        """

        self._age = age
    
    #add by FAO
    def __lt__(self, other):
        if self.last_name ==  other.last_name:
            return self.first_name < other.first_name
        return self.last_name < other.last_name

    def __le__(self, other):
        if self.last_name ==  other.last_name:
            return self.first_name <= other.first_name
        return self.last_name <= other.last_name

    def __eq__(self, other):
        if self.last_name ==  other.last_name:
            return self.first_name == other.first_name
        return self.last_name == other.last_name

    def __ne__(self, other):
        if self.last_name !=  other.last_name:
            return self.first_name != other.first_name
        return self.last_name != other.last_name

    def __gt__(self, other):
        if self.last_name ==  other.last_name:
            return self.first_name > other.first_name
        return self.last_name > other.last_name

    def __ge__(self, other):
        if self.last_name ==  other.last_name:
            return self.first_name >= other.first_name
        return self.last_name >= other.last_name
    
    def __str__(self):
        return "%s %s" % (self.first_name, self.last_name)
